;; Problem 22
;; 19 July 2002

;; Using names.txt (right click and 'Save Link/Target As...'), a 46K
;; text file containing over five-thousand first names, begin by
;; sorting it into alphabetical order. Then working out the
;; alphabetical value for each name, multiply this value by its
;; alphabetical position in the list to obtain a name score.

;; For example, when the list is sorted into alphabetical order,
;; COLIN, which is worth 3 + 15 + 12 + 9 + 14 = 53, is the 938th name
;; in the list. So, COLIN would obtain a score of 938 53 = 49714.

;; What is the total of all the name scores in the file?

(defvar *names-file* "/home/mortis/personal/projects/project-euler.net/names-by-lines.txt")

(defun stream->lines (stream)
  (let ((lines (list)))
    (loop
     (multiple-value-bind (line nl) (read-line stream nil stream)
       (when (eq line stream)
         (return))
       (push line lines)))
    lines))

(defun strip-quotes (str)
  (subseq str 1 (- (length str) 1)))

;(strip-quotes "abdc")

(defun get-names ()
  (mapcar
   #'strip-quotes
   (with-open-file (inp *names-file*)
     (stream->lines inp))))

(defvar *sorted-names*
  (sort (get-names)
	#'string<))

(defun get-sorted-names ()
  (sort (get-names)
	#'string<))

(defvar *alphabet-chars* 
  '(#\A #\B #\C #\D #\E #\F #\G #\H #\I #\J #\K #\L #\M
    #\N #\O #\P #\Q #\R #\S #\T #\U #\V #\W #\X #\Y #\Z))

(defvar *alpha-scores*
  (loop for char in *alphabet-chars*
	for score = 1 then (+ score 1)
	collect
	(list char score)))

(defvar *alpha-score-table*
  (make-hash-table))

(loop for (ch score) in *alpha-scores*
      do
      (setf (gethash ch *alpha-score-table*) score))

(defun char-value (ch)
  (gethash ch *alpha-score-table*))
	 
(defun name-value (name)
  (loop for ch across name
	for score = (char-value ch) then (+ score (char-value ch))
	finally (return score)))

;(char-value #\z)
;(name-value "COLIN")

(time
 (let ((total 0))
   (loop for name in (get-sorted-names)
	 for lnum = 1 then (+ lnum 1)
	 do
	 (if (equalp "COLIN" name)
	     (format t "name:~a lnum:~a value:~a score:~a~&"
		     name
		     lnum
		     (name-value name)
		     (* (name-value name) lnum)))
	 (setf total (+ total (* lnum (name-value name)))))
   (format t "total:~a~&" total)
   total))
;; total:871,198,282